function [outc]=COVlam3d(x1,x2,x3)

%Accepts X1<X2<X3. Yields as an output the Variance Covariance matrix
%of the m1, s1, m2, s2, m3, s3, and lam, (with this order) where lam is the estimated boxcox
%parameter. Thus, the output will be a 7x7 matrix.



n1=length(x1);
n2=length(x2);
n3=length(x3);



 
%logL=@(g) (-n*log(g(2))-1/(2*g(2)^2)*sum((((x.^g(5)-1)./g(5))-g(1)).^2)+(g(5)-1)*sum(log(x))   -m*log(g(4))-1/(2*g(4)^2)*sum((((y.^g(5)-1)./g(5))-g(3)).^2)+(g(5)-1)*sum(log(y)));

logL=@(g) (-n1*log(g(2))-1/(2*g(2)^2)*sum((((x1.^g(7)-1)./g(7))-g(1)).^2)+(g(7)-1)*sum(log(x1))+...
           -n2*log(g(4))-1/(2*g(4)^2)*sum((((x2.^g(7)-1)./g(7))-g(3)).^2)+(g(7)-1)*sum(log(x2))+...
           -n3*log(g(6))-1/(2*g(6)^2)*sum((((x3.^g(7)-1)./g(7))-g(5)).^2)+(g(7)-1)*sum(log(x3)));

       
       
if min(x1)<0 || min(x2)<0 || min(x3)<0;error('the data are negative');end       
[transx1 transx2 transx3 lam exitflag]=boxcox3d(x1,x2,x3);
%if exitflag~=1;error('the boxcox3d did not converge');end
if exitflag~=1;warning('the boxcox3d did not converge');end

%laaaaam=lam

s1=sqrt(1./(length(transx1))*sum((transx1-mean(transx1)).^2));
s2=sqrt(1./(length(transx2))*sum((transx2-mean(transx2)).^2));
s3=sqrt(1./(length(transx3))*sum((transx3-mean(transx3)).^2));


 m1=mean(transx1);  %s1=std(transx1); 
 m2=mean(transx2);  %s2=std(transx2);
 m3=mean(transx3);  %s3=std(transx3);
 
 %------THIS SECTION COMPLETELY AGRREES WITH THE NEXT (THIS FINDS THE IM numerically)
%[m1 s1 m2 s2 m3 s3 lam]
%   [h,err] = hessian(logL,[m1 s1 m2 s2 m3 s3 lam]);
%   
%   h(1,2)=0;h(1,3)=0;h(1,4)=0;h(1,5)=0;h(1,6)=0;
%   h(2,3)=0;h(2,4)=0;h(2,5)=0;h(2,6)=0;
%   h(3,4)=0;h(3,5)=0;h(3,6)=0;
%   h(4,5)=0;h(4,6)=0;
%   h(5,6)=0;
%  
%   h(2,1)=0;h(3,1)=0;h(4,1)=0;h(5,1)=0;h(6,1)=0;
%   h(3,2)=0;h(4,2)=0;h(5,2)=0;h(6,2)=0;
%   h(4,3)=0;h(5,3)=0;h(6,3)=0;
%   h(5,4)=0;h(6,4)=0;
%   h(6,5)=0;%  
%   IMnum=-h;
% 

%------END OF THIS SECTION THAT FINDS THE IM numerically)

 
%diagonal:
IMc(1,1)=n1/s1^2;
IMc(2,2)=-(n1/s1^2-3/s1^4.*sum((transx1-m1).^2));   % I(2,2)=-(n/sh^2-3/sh^4*sum((xlam-mh).^2)); %Ben is correct
IMc(3,3)=n2/s2^2;
IMc(4,4)=-(n2/s2^2-3/s2^4.*sum((transx2-m2).^2));
IMc(5,5)=n3/s3^2;
IMc(6,6)=-(n3/s3^2-3/s3^4.*sum((transx3-m3).^2));
IMca=sum((4.*(m1 - x1.^lam.*log(x1)).*(lam.*m1 - x1.^lam + 1))./(lam.^3.*s1.^2) - (m1 - x1.^lam.*log(x1)).^2./(lam.^2.*s1.^2) - (3.*(lam.*m1 - x1.^lam + 1).^2)./(lam.^4.*s1.^2) + (x1.^lam.*log(x1).^2.*(lam.*m1 - x1.^lam + 1))./(lam.^2.*s1.^2));
IMcb=sum((4.*(m2 - x2.^lam.*log(x2)).*(lam.*m2 - x2.^lam + 1))./(lam.^3.*s2.^2) - (m2 - x2.^lam.*log(x2)).^2./(lam.^2.*s2.^2) - (3.*(lam.*m2 - x2.^lam + 1).^2)./(lam.^4.*s2.^2) + (x2.^lam.*log(x2).^2.*(lam.*m2 - x2.^lam + 1))./(lam.^2.*s2.^2));
IMcc=sum((4.*(m3 - x3.^lam.*log(x3)).*(lam.*m3 - x3.^lam + 1))./(lam.^3.*s3.^2) - (m3 - x3.^lam.*log(x3)).^2./(lam.^2.*s3.^2) - (3.*(lam.*m3 - x3.^lam + 1).^2)./(lam.^4.*s3.^2) + (x3.^lam.*log(x3).^2.*(lam.*m3 - x3.^lam + 1))./(lam.^2.*s3.^2));
IMc(7,7)=-(IMca+IMcb+IMcc)  ;

%last column:
IMc(1,7)=  sum(((2.*(x1.^lam - 1))./lam.^2 - (2.*x1.^lam.*log(x1))./lam)./(2.*s1.^2));
IMc(2,7)=-sum((2.*((x1.^lam - 1)./lam.^2 - (x1.^lam.*log(x1))./lam).*(m1 - (x1.^lam - 1)./lam))./s1^3);
IMc(3,7)=  sum(((2.*(x2.^lam - 1))./lam.^2 - (2.*x2.^lam.*log(x2))./lam)./(2.*s2.^2));
IMc(4,7)=-sum((2.*((x2.^lam - 1)./lam.^2 - (x2.^lam.*log(x2))./lam).*(m2 - (x2.^lam - 1)./lam))./s2^3);
IMc(5,7)=  sum(((2.*(x3.^lam - 1))./lam.^2 - (2.*x3.^lam.*log(x3))./lam)./(2.*s3.^2));
IMc(6,7)=-sum((2.*((x3.^lam - 1)./lam.^2 - (x3.^lam.*log(x3))./lam).*(m3 - (x3.^lam - 1)./lam))./s3^3);



%IMc(1,7)=sum((m1 - x1.^lam.*log(x1))./(lam.*s1.^2) - (lam.*m1 - x1.^lam + 1)./(lam.^2.*s1.^2));
%IMc(2,7)=sum((2.*(lam.*m1 - x1.^lam + 1).^2)./(lam.^3.*s1.^3) - (2.*(m1 - x1.^lam.*log(x1)).*(lam.*m1 - x1.^lam + 1))./(lam.^2.*s1.^3));
%IMc(3,7)=sum((m2 - x2.^lam.*log(x2))./(lam.*s2.^2) - (lam.*m2 - x2.^lam + 1)./(lam.^2.*s2.^2)); 
%IMc(4,7)=sum((2.*(lam.*m2 - x2.^lam + 1).^2)./(lam.^3.*s2.^3) - (2.*(m2 - x2.^lam.*log(x2)).*(lam.*m2 - x2.^lam + 1))./(lam.^2.*s2.^3));
%IMc(5,7)=sum((m3 - x3.^lam.*log(x3))./(lam.*s3.^2) - (lam.*m3 - x3.^lam + 1)./(lam.^2.*s3.^2)); 
%IMc(6,7)=sum((2.*(lam.*m3 - x3.^lam + 1).^2)./(lam.^3.*s3.^3) - (2.*(m3 - x3.^lam.*log(x3)).*(lam.*m3 - x3.^lam + 1))./(lam.^2.*s3.^3));

%last row:
IMc(end,:)=IMc(:,end);


% 
% logL=     (-n1*log(s1)-1/(2*s1^2)*sum((((x1.^lam-1)./lam)-m1).^2)+(lam-1)*sum(log(x1))+...
%            -n2*log(s2)-1/(2*s2^2)*sum((((x2.^lam-1)./lam)-m2).^2)+(lam-1)*sum(log(x2))+...
%            -n3*log(s3)-1/(2*s3^2)*sum((((x3.^lam-1)./lam)-m3).^2)+(lam-1)*sum(log(x3)));
% 


 Sc=inv(IMc);

 outc=Sc;
 
 
 
 
end
 
 

 

 
	