
function [AUC, SE, CI, ppvalue, ppvalueonesided, Se_at_Sp95, Sp_at_Se95 ,Se_at_Sp99 ,Sp_at_Se99, X, Y]=inferlogAUC(G,Dnew)
    aa=1;
    rand('twister', 5493+aa);
      randn('state', 3+aa);
      randn('seed',3+aa);
      rand('seed',3+aa);
%Inputs:
% G: a matrix that each row is a biomarker to be combined
% Dnew: disease status (0 for healthy and 1 for the diseased)
%Output:
% AUC, CI, pvalue
na=length(find(Dnew==0));
nb=length(find(Dnew==1));

bhat=glmfit(G,Dnew,'binomial', 'link', 'logit')
S=[ones(size(G,1),1) G];
score=(bhat'*S')'; % %score=b(1)+b(2)*y1+b(3)*y2
[X,Y,T,AUC] = perfcurve(Dnew,score,1);
point_estimate_of_AUC=AUC
Se_at_Sp95=roct(0.05,X,Y);
Sp_at_Se95=1-roct(0.95,Y,X);
Se_at_Sp99=roct(0.01,X,Y);
Sp_at_Se99=1-roct(0.99,Y,X);



boots=1;
while boots<=1000
    boots
    lastwarn('')
    bhat=glmfit(G,Dnew,'binomial', 'link', 'logit');
    ata=randsample(1:na,na,'true');
    atb=randsample(1:nb,nb,'true');
    Ga=removerows(G,'ind',find(Dnew==1));
    Gb=removerows(G,'ind',find(Dnew==0));
    Gaboots=Ga(ata,:);
    Gbboots=Gb(atb,:);
    Gboots=[Gaboots;Gbboots];
    bhatboots=glmfit(Gboots,[zeros(na,1);ones(nb,1)],'binomial', 'link', 'logit');
    Sboots=[ones(size(Gboots,1),1) Gboots];
    scoreboots=(bhatboots'*Sboots')'; % %score=b(1)+b(2)*y1+b(3)*y2
    [Xboots,Yboots,Tboots,AUCboots(boots)] = perfcurve([zeros(na,1);ones(nb,1)],scoreboots,1);
    if isempty(lastwarn)==1;boots=boots+1;end
    
end
AUCboots;

CI=[AUC-1.96*sqrt(var(AUCboots)) AUC+1.96*sqrt(var(AUCboots))];
Z=(AUC)./sqrt(var(AUCboots));
ppvalue=2*normcdf(-abs(Z));
ppvalueonesided=ppvalue/2;
SE=sqrt(var(AUCboots));
end
