close all
clear all
clc

syms m1hat s1hat m2hat s2hat m3hat s3hat n1 n2 n3


%----Estimate the two thresholds based on binormality:
c1A=(m2hat.*s1hat.^2-m1hat.*s2hat^2);
c1B=s1hat.*s2hat.*sqrt((m1hat-m2hat).^2+(s1hat^2-s2hat^2).*log(s1hat^2/s2hat^2));
c1C=s1hat^2-s2hat^2;
c1hat=(c1A-c1B)/c1C;

c2A=(m3hat.*s2hat.^2-m2hat.*s3hat^2);
c2B=s2hat.*s3hat.*sqrt((m2hat-m3hat).^2+(s2hat^2-s3hat^2).*log(s2hat^2/s3hat^2));
c2C=s2hat^2-s3hat^2;
c2hat=(c2A-c2B)/c2C;

%-----------------------------------
varm1=s1hat^2/n1; varm2=s2hat^2/n2; varm3=s3hat^2/n3;
vars1=s1hat^2/(2*(n1-1)); vars2=s2hat^2/(2*(n2-1)); vars3=s3hat^2/(2*(n3-1));

F21=normcdf_sym((c2hat-m1hat)/s1hat)-normcdf_sym((c1hat-m1hat)/s1hat)
F31=1-normcdf_sym((c2hat-m1hat)/s1hat)
F12=normcdf_sym((c1hat-m2hat)/s2hat)
F32=1-normcdf_sym((c2hat-m2hat)/s2hat)
F13=normcdf_sym((c1hat-m3hat)/s3hat)
F23=normcdf_sym((c2hat-m3hat)/s3hat)-normcdf_sym((c1hat-m3hat)/s3hat)

norminvF21=norminv_sym(F21)
norminvF31=norminv_sym(F31)
norminvF12=norminv_sym(F12)
norminvF32=norminv_sym(F32)
norminvF13=norminv_sym(F13)
norminvF23=norminv_sym(F23)

%----partial derivatives numerical:
dinvF21m1=diff(norminvF21,'m1hat')
dinvF21s1=diff(norminvF21,'s1hat')
dinvF21m2=diff(norminvF21,'m2hat')
dinvF21s2=diff(norminvF21,'s2hat')
dinvF21m3=diff(norminvF21,'m3hat')
dinvF21s3=diff(norminvF21,'s3hat')
% 
dinvF31m1=diff(norminvF31,'m1hat')
dinvF31s1=diff(norminvF31,'s1hat')
dinvF31m2=diff(norminvF31,'m2hat')
dinvF31s2=diff(norminvF31,'s2hat')
dinvF31m3=diff(norminvF31,'m3hat')
dinvF31s3=diff(norminvF31,'s3hat')
% 
dinvF12m1=diff(norminvF12,'m1hat')
dinvF12s1=diff(norminvF12,'s1hat')
dinvF12m2=diff(norminvF12,'m2hat')
dinvF12s2=diff(norminvF12,'s2hat')
dinvF12m3=diff(norminvF12,'m3hat')
dinvF12s3=diff(norminvF12,'s3hat')
% 
dinvF32m1=diff(norminvF32,'m1hat')
dinvF32s1=diff(norminvF32,'s1hat')
dinvF32m2=diff(norminvF32,'m2hat')
dinvF32s2=diff(norminvF32,'s2hat')
dinvF32m3=diff(norminvF32,'m3hat')
dinvF32s3=diff(norminvF32,'s3hat')
% 
dinvF13m1=diff(norminvF13,'m1hat')
dinvF13s1=diff(norminvF13,'s1hat')
dinvF13m2=diff(norminvF13,'m2hat')
dinvF13s2=diff(norminvF13,'s2hat')
dinvF13m3=diff(norminvF13,'m3hat')
dinvF13s3=diff(norminvF13,'s3hat')
% 
dinvF23m1=diff(norminvF23,'m1hat')
dinvF23s1=diff(norminvF23,'s1hat')
dinvF23m2=diff(norminvF23,'m2hat')
dinvF23s2=diff(norminvF23,'s2hat')
dinvF23m3=diff(norminvF23,'m3hat')
dinvF23s3=diff(norminvF23,'s3hat')


%---------------------------------


