function [Jhat, vus, outvolume, outrect, marginalCIs, deltas, TC123, covdeltas, cutoffs, covdeltas_plot]=fdeltaegg(x1,x2,x3)

%----Estimation Procedure:

n1=length(x1);n2=length(x2);n3=length(x3);

[m1hat s1hat]=normfit(x1);
[m2hat s2hat]=normfit(x2);
[m3hat s3hat]=normfit(x3);


ROCsurf=@(p1,p3) (norminv(1-p3,m3hat,s3hat)>norminv(p1,m1hat,s1hat)).*(normcdf(norminv(1-p3,m3hat,s3hat),m2hat,s2hat)-...
      normcdf(norminv(p1,m1hat,s1hat),m2hat,s2hat));

%----plot the ROC surface:
[p1,p3] = meshgrid(0:0.01:1, 0:0.01:1);
ROCsparam= (norminv(1-p3,m3hat,s3hat)>norminv(p1,m1hat,s1hat)).*(normcdf(norminv(1-p3,m3hat,s3hat),m2hat,s2hat)-...
normcdf(norminv(p1,m1hat,s1hat),m2hat,s2hat));
surf(p1,p3,ROCsparam) %plot the ROC surface
shading interp
alpha(0.3)
hold on
%-------------------


%----Estimate the two thresholds based on binormality:
c1A=(m2hat.*s1hat.^2-m1hat.*s2hat^2);
c1B=s1hat.*s2hat.*sqrt((m1hat-m2hat).^2+(s1hat^2-s2hat^2).*log(s1hat^2/s2hat^2));
c1C=s1hat^2-s2hat^2;
c1hat=(c1A-c1B)/c1C;

c2A=(m3hat.*s2hat.^2-m2hat.*s3hat^2);
c2B=s2hat.*s3hat.*sqrt((m2hat-m3hat).^2+(s2hat^2-s3hat^2).*log(s2hat^2/s3hat^2));
c2C=s2hat^2-s3hat^2;
c2hat=(c2A-c2B)/c2C;
Jhat=0.5*(normcdf((c1hat-m1hat)/s1hat)-normcdf((c1hat-m2hat)/s2hat)+normcdf((c2hat-m2hat)/s2hat)-normcdf((c2hat-m3hat)/s3hat));


%Monte Carlo estimates of deltas
delta1 =(c1hat-m1hat)/s1hat;
%delta3 =(c2hat-m3hat)/s3hat;
delta3 =(m3hat-c2hat)/s3hat;
delta2a=normcdf((c2hat-m2hat)/s2hat);
delta2b=normcdf((c1hat-m2hat)/s2hat);
delta2 =norminv(delta2a-delta2b);

delta1hat=delta1 ;
delta2hat=delta2 ;
delta3hat=delta3 ;
%-----------------------------------



%----partial derivatives numerical:
d1m1=-((s2hat^2 + (s1hat*s2hat*(2*m1hat - 2*m2hat))/(2*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))/(s1hat^2 - s2hat^2) + 1)/s1hat;
d1m2=(s1hat^2 + (s1hat*s2hat*(2*m1hat - 2*m2hat))/(2*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))/(s1hat*(s1hat^2 - s2hat^2));
d1m3=0;

d2m1=(2*(s2hat^2 + (s1hat*s2hat*(2*m1hat - 2*m2hat))/(2*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))*(((log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 + 2437993681642287/562949953421312)^2 - (1000*log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2))/147)^(1/2) - log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 - 2437993681642287/562949953421312)^(1/2))/(pi^(1/2)*s2hat*exp((m2hat + (m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2))/(s1hat^2 - s2hat^2))^2/(2*s2hat^2))*abs(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)*(s1hat^2 - s2hat^2)) - (2^(1/2)*(((2000*2^(1/2)*(s2hat^2 + (s1hat*s2hat*(2*m1hat - 2*m2hat))/(2*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))*(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1))/(147*pi^(1/2)*s2hat*exp((m2hat + (m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2))/(s1hat^2 - s2hat^2))^2/(2*s2hat^2))*(s1hat^2 - s2hat^2)*((erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2 - 1)) - (2*2^(1/2)*(log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 + 2437993681642287/562949953421312)*(s2hat^2 + (s1hat*s2hat*(2*m1hat - 2*m2hat))/(2*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))*(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1))/(pi^(1/2)*s2hat*exp((m2hat + (m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2))/(s1hat^2 - s2hat^2))^2/(2*s2hat^2))*(s1hat^2 - s2hat^2)*((erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2 - 1)))/(2*((log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 + 2437993681642287/562949953421312)^2 - (1000*log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2))/147)^(1/2)) + (2^(1/2)*(s2hat^2 + (s1hat*s2hat*(2*m1hat - 2*m2hat))/(2*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))*(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1))/(pi^(1/2)*s2hat*exp((m2hat + (m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2))/(s1hat^2 - s2hat^2))^2/(2*s2hat^2))*(s1hat^2 - s2hat^2)*((erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2 - 1)))*(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1))/(2*abs(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)*(((log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 + 2437993681642287/562949953421312)^2 - (1000*log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2))/147)^(1/2) - log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 - 2437993681642287/562949953421312)^(1/2)) - (2*sign(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)*(s2hat^2 + (s1hat*s2hat*(2*m1hat - 2*m2hat))/(2*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))*(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)*(((log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 + 2437993681642287/562949953421312)^2 - (1000*log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2))/147)^(1/2) - log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 - 2437993681642287/562949953421312)^(1/2))/(pi^(1/2)*s2hat*exp((m2hat + (m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2))/(s1hat^2 - s2hat^2))^2/(2*s2hat^2))*abs(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2*(s1hat^2 - s2hat^2));
d2m2=(2^(1/2)*(((2000*((2^(1/2)*((s1hat^2 + (s1hat*s2hat*(2*m1hat - 2*m2hat))/(2*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))/(s1hat^2 - s2hat^2) - 1))/(pi^(1/2)*s2hat*exp((m2hat + (m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2))/(s1hat^2 - s2hat^2))^2/(2*s2hat^2))) + (2^(1/2)*((s3hat^2 + (s2hat*s3hat*(2*m2hat - 2*m3hat))/(2*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))/(s2hat^2 - s3hat^2) + 1))/(pi^(1/2)*s2hat*exp((m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2))^2/(2*s2hat^2))))*(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1))/(147*((erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2 - 1)) - (2*((2^(1/2)*((s1hat^2 + (s1hat*s2hat*(2*m1hat - 2*m2hat))/(2*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))/(s1hat^2 - s2hat^2) - 1))/(pi^(1/2)*s2hat*exp((m2hat + (m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2))/(s1hat^2 - s2hat^2))^2/(2*s2hat^2))) + (2^(1/2)*((s3hat^2 + (s2hat*s3hat*(2*m2hat - 2*m3hat))/(2*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))/(s2hat^2 - s3hat^2) + 1))/(pi^(1/2)*s2hat*exp((m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2))^2/(2*s2hat^2))))*(log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 + 2437993681642287/562949953421312)*(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1))/((erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2 - 1))/(2*((log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 + 2437993681642287/562949953421312)^2 - (1000*log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2))/147)^(1/2)) + (((2^(1/2)*((s1hat^2 + (s1hat*s2hat*(2*m1hat - 2*m2hat))/(2*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))/(s1hat^2 - s2hat^2) - 1))/(pi^(1/2)*s2hat*exp((m2hat + (m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2))/(s1hat^2 - s2hat^2))^2/(2*s2hat^2))) + (2^(1/2)*((s3hat^2 + (s2hat*s3hat*(2*m2hat - 2*m3hat))/(2*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))/(s2hat^2 - s3hat^2) + 1))/(pi^(1/2)*s2hat*exp((m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2))^2/(2*s2hat^2))))*(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1))/((erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2 - 1))*(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1))/(2*abs(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)*(((log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 + 2437993681642287/562949953421312)^2 - (1000*log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2))/147)^(1/2) - log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 - 2437993681642287/562949953421312)^(1/2)) - (2^(1/2)*((2^(1/2)*((s1hat^2 + (s1hat*s2hat*(2*m1hat - 2*m2hat))/(2*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))/(s1hat^2 - s2hat^2) - 1))/(pi^(1/2)*s2hat*exp((m2hat + (m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2))/(s1hat^2 - s2hat^2))^2/(2*s2hat^2))) + (2^(1/2)*((s3hat^2 + (s2hat*s3hat*(2*m2hat - 2*m3hat))/(2*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))/(s2hat^2 - s3hat^2) + 1))/(pi^(1/2)*s2hat*exp((m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2))^2/(2*s2hat^2))))*(((log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 + 2437993681642287/562949953421312)^2 - (1000*log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2))/147)^(1/2) - log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 - 2437993681642287/562949953421312)^(1/2))/abs(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1) + (2^(1/2)*sign(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)*((2^(1/2)*((s1hat^2 + (s1hat*s2hat*(2*m1hat - 2*m2hat))/(2*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))/(s1hat^2 - s2hat^2) - 1))/(pi^(1/2)*s2hat*exp((m2hat + (m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2))/(s1hat^2 - s2hat^2))^2/(2*s2hat^2))) + (2^(1/2)*((s3hat^2 + (s2hat*s3hat*(2*m2hat - 2*m3hat))/(2*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))/(s2hat^2 - s3hat^2) + 1))/(pi^(1/2)*s2hat*exp((m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2))^2/(2*s2hat^2))))*(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)*(((log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 + 2437993681642287/562949953421312)^2 - (1000*log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2))/147)^(1/2) - log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 - 2437993681642287/562949953421312)^(1/2))/abs(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2;
d2m3=(2*(s2hat^2 + (s2hat*s3hat*(2*m2hat - 2*m3hat))/(2*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))*(((log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 + 2437993681642287/562949953421312)^2 - (1000*log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2))/147)^(1/2) - log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 - 2437993681642287/562949953421312)^(1/2))/(pi^(1/2)*s2hat*exp((m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2))^2/(2*s2hat^2))*abs(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)*(s2hat^2 - s3hat^2)) - (2^(1/2)*(((2000*2^(1/2)*(s2hat^2 + (s2hat*s3hat*(2*m2hat - 2*m3hat))/(2*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))*(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1))/(147*pi^(1/2)*s2hat*exp((m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2))^2/(2*s2hat^2))*(s2hat^2 - s3hat^2)*((erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2 - 1)) - (2*2^(1/2)*(log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 + 2437993681642287/562949953421312)*(s2hat^2 + (s2hat*s3hat*(2*m2hat - 2*m3hat))/(2*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))*(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1))/(pi^(1/2)*s2hat*exp((m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2))^2/(2*s2hat^2))*(s2hat^2 - s3hat^2)*((erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2 - 1)))/(2*((log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 + 2437993681642287/562949953421312)^2 - (1000*log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2))/147)^(1/2)) + (2^(1/2)*(s2hat^2 + (s2hat*s3hat*(2*m2hat - 2*m3hat))/(2*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))*(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1))/(pi^(1/2)*s2hat*exp((m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2))^2/(2*s2hat^2))*(s2hat^2 - s3hat^2)*((erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2 - 1)))*(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1))/(2*abs(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)*(((log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 + 2437993681642287/562949953421312)^2 - (1000*log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2))/147)^(1/2) - log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 - 2437993681642287/562949953421312)^(1/2)) - (2*sign(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)*(s2hat^2 + (s2hat*s3hat*(2*m2hat - 2*m3hat))/(2*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))*(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)*(((log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 + 2437993681642287/562949953421312)^2 - (1000*log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2))/147)^(1/2) - log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 - 2437993681642287/562949953421312)^(1/2))/(pi^(1/2)*s2hat*exp((m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2))^2/(2*s2hat^2))*abs(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2*(s2hat^2 - s3hat^2));
  
d3m1=0;
d3m2=(s3hat^2 + (s2hat*s3hat*(2*m2hat - 2*m3hat))/(2*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))/(s3hat*(s2hat^2 - s3hat^2));
d3m3=-((s2hat^2 + (s2hat*s3hat*(2*m2hat - 2*m3hat))/(2*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))/(s2hat^2 - s3hat^2) - 1)/s3hat;
 

d1s1=(m1hat + (m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2))/(s1hat^2 - s2hat^2))/s1hat^2 - ((s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2) - 2*m2hat*s1hat + (s1hat*s2hat*(2*s1hat*log(s1hat^2/s2hat^2) + (2*(s1hat^2 - s2hat^2))/s1hat))/(2*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))/(s1hat^2 - s2hat^2) - (2*s1hat*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))/(s1hat^2 - s2hat^2)^2)/s1hat;
d1s2=-((2*m1hat*s2hat + s1hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2) - (s1hat*s2hat*(2*s2hat*log(s1hat^2/s2hat^2) + (2*(s1hat^2 - s2hat^2))/s2hat))/(2*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))/(s1hat^2 - s2hat^2) + (2*s2hat*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))/(s1hat^2 - s2hat^2)^2)/s1hat;
d1s3=0;

d2s1=(2*((s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2) - 2*m2hat*s1hat + (s1hat*s2hat*(2*s1hat*log(s1hat^2/s2hat^2) + (2*(s1hat^2 - s2hat^2))/s1hat))/(2*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))/(s1hat^2 - s2hat^2) - (2*s1hat*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))/(s1hat^2 - s2hat^2)^2)*(((log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 + 2437993681642287/562949953421312)^2 - (1000*log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2))/147)^(1/2) - log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 - 2437993681642287/562949953421312)^(1/2))/(pi^(1/2)*s2hat*exp((m2hat + (m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2))/(s1hat^2 - s2hat^2))^2/(2*s2hat^2))*abs(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)) - (2^(1/2)*(((2000*2^(1/2)*((s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2) - 2*m2hat*s1hat + (s1hat*s2hat*(2*s1hat*log(s1hat^2/s2hat^2) + (2*(s1hat^2 - s2hat^2))/s1hat))/(2*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))/(s1hat^2 - s2hat^2) - (2*s1hat*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))/(s1hat^2 - s2hat^2)^2)*(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1))/(147*pi^(1/2)*s2hat*exp((m2hat + (m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2))/(s1hat^2 - s2hat^2))^2/(2*s2hat^2))*((erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2 - 1)) - (2*2^(1/2)*(log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 + 2437993681642287/562949953421312)*((s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2) - 2*m2hat*s1hat + (s1hat*s2hat*(2*s1hat*log(s1hat^2/s2hat^2) + (2*(s1hat^2 - s2hat^2))/s1hat))/(2*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))/(s1hat^2 - s2hat^2) - (2*s1hat*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))/(s1hat^2 - s2hat^2)^2)*(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1))/(pi^(1/2)*s2hat*exp((m2hat + (m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2))/(s1hat^2 - s2hat^2))^2/(2*s2hat^2))*((erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2 - 1)))/(2*((log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 + 2437993681642287/562949953421312)^2 - (1000*log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2))/147)^(1/2)) + (2^(1/2)*((s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2) - 2*m2hat*s1hat + (s1hat*s2hat*(2*s1hat*log(s1hat^2/s2hat^2) + (2*(s1hat^2 - s2hat^2))/s1hat))/(2*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))/(s1hat^2 - s2hat^2) - (2*s1hat*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))/(s1hat^2 - s2hat^2)^2)*(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1))/(pi^(1/2)*s2hat*exp((m2hat + (m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2))/(s1hat^2 - s2hat^2))^2/(2*s2hat^2))*((erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2 - 1)))*(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1))/(2*abs(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)*(((log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 + 2437993681642287/562949953421312)^2 - (1000*log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2))/147)^(1/2) - log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 - 2437993681642287/562949953421312)^(1/2)) - (2*sign(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)*((s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2) - 2*m2hat*s1hat + (s1hat*s2hat*(2*s1hat*log(s1hat^2/s2hat^2) + (2*(s1hat^2 - s2hat^2))/s1hat))/(2*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))/(s1hat^2 - s2hat^2) - (2*s1hat*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))/(s1hat^2 - s2hat^2)^2)*(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)*(((log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 + 2437993681642287/562949953421312)^2 - (1000*log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2))/147)^(1/2) - log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 - 2437993681642287/562949953421312)^(1/2))/(pi^(1/2)*s2hat*exp((m2hat + (m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2))/(s1hat^2 - s2hat^2))^2/(2*s2hat^2))*abs(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2);
d2s2=(2^(1/2)*((2*((2^(1/2)*((2*m1hat*s2hat + s1hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2) - (s1hat*s2hat*(2*s2hat*log(s1hat^2/s2hat^2) + (2*(s1hat^2 - s2hat^2))/s2hat))/(2*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))/(s1hat^2 - s2hat^2) + (2*s2hat*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))/(s1hat^2 - s2hat^2)^2))/(2*s2hat) - (2^(1/2)*(m2hat + (m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2))/(s1hat^2 - s2hat^2)))/(2*s2hat^2)))/(pi^(1/2)*exp((m2hat + (m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2))/(s1hat^2 - s2hat^2))^2/(2*s2hat^2))) - (2*((2^(1/2)*((s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2) - 2*m3hat*s2hat + (s2hat*s3hat*(2*s2hat*log(s2hat^2/s3hat^2) + (2*(s2hat^2 - s3hat^2))/s2hat))/(2*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))/(s2hat^2 - s3hat^2) - (2*s2hat*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))/(s2hat^2 - s3hat^2)^2))/(2*s2hat) - (2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat^2)))/(pi^(1/2)*exp((m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2))^2/(2*s2hat^2))))*(((log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 + 2437993681642287/562949953421312)^2 - (1000*log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2))/147)^(1/2) - log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 - 2437993681642287/562949953421312)^(1/2))/abs(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1) - (2^(1/2)*(((2000*((2*((2^(1/2)*((2*m1hat*s2hat + s1hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2) - (s1hat*s2hat*(2*s2hat*log(s1hat^2/s2hat^2) + (2*(s1hat^2 - s2hat^2))/s2hat))/(2*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))/(s1hat^2 - s2hat^2) + (2*s2hat*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))/(s1hat^2 - s2hat^2)^2))/(2*s2hat) - (2^(1/2)*(m2hat + (m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2))/(s1hat^2 - s2hat^2)))/(2*s2hat^2)))/(pi^(1/2)*exp((m2hat + (m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2))/(s1hat^2 - s2hat^2))^2/(2*s2hat^2))) - (2*((2^(1/2)*((s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2) - 2*m3hat*s2hat + (s2hat*s3hat*(2*s2hat*log(s2hat^2/s3hat^2) + (2*(s2hat^2 - s3hat^2))/s2hat))/(2*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))/(s2hat^2 - s3hat^2) - (2*s2hat*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))/(s2hat^2 - s3hat^2)^2))/(2*s2hat) - (2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat^2)))/(pi^(1/2)*exp((m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2))^2/(2*s2hat^2))))*(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1))/(147*((erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2 - 1)) - (2*(log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 + 2437993681642287/562949953421312)*((2*((2^(1/2)*((2*m1hat*s2hat + s1hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2) - (s1hat*s2hat*(2*s2hat*log(s1hat^2/s2hat^2) + (2*(s1hat^2 - s2hat^2))/s2hat))/(2*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))/(s1hat^2 - s2hat^2) + (2*s2hat*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))/(s1hat^2 - s2hat^2)^2))/(2*s2hat) - (2^(1/2)*(m2hat + (m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2))/(s1hat^2 - s2hat^2)))/(2*s2hat^2)))/(pi^(1/2)*exp((m2hat + (m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2))/(s1hat^2 - s2hat^2))^2/(2*s2hat^2))) - (2*((2^(1/2)*((s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2) - 2*m3hat*s2hat + (s2hat*s3hat*(2*s2hat*log(s2hat^2/s3hat^2) + (2*(s2hat^2 - s3hat^2))/s2hat))/(2*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))/(s2hat^2 - s3hat^2) - (2*s2hat*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))/(s2hat^2 - s3hat^2)^2))/(2*s2hat) - (2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat^2)))/(pi^(1/2)*exp((m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2))^2/(2*s2hat^2))))*(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1))/((erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2 - 1))/(2*((log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 + 2437993681642287/562949953421312)^2 - (1000*log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2))/147)^(1/2)) + (((2*((2^(1/2)*((2*m1hat*s2hat + s1hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2) - (s1hat*s2hat*(2*s2hat*log(s1hat^2/s2hat^2) + (2*(s1hat^2 - s2hat^2))/s2hat))/(2*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))/(s1hat^2 - s2hat^2) + (2*s2hat*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))/(s1hat^2 - s2hat^2)^2))/(2*s2hat) - (2^(1/2)*(m2hat + (m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2))/(s1hat^2 - s2hat^2)))/(2*s2hat^2)))/(pi^(1/2)*exp((m2hat + (m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2))/(s1hat^2 - s2hat^2))^2/(2*s2hat^2))) - (2*((2^(1/2)*((s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2) - 2*m3hat*s2hat + (s2hat*s3hat*(2*s2hat*log(s2hat^2/s3hat^2) + (2*(s2hat^2 - s3hat^2))/s2hat))/(2*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))/(s2hat^2 - s3hat^2) - (2*s2hat*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))/(s2hat^2 - s3hat^2)^2))/(2*s2hat) - (2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat^2)))/(pi^(1/2)*exp((m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2))^2/(2*s2hat^2))))*(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1))/((erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2 - 1))*(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1))/(2*abs(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)*(((log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 + 2437993681642287/562949953421312)^2 - (1000*log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2))/147)^(1/2) - log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 - 2437993681642287/562949953421312)^(1/2)) - (2^(1/2)*sign(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)*((2*((2^(1/2)*((2*m1hat*s2hat + s1hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2) - (s1hat*s2hat*(2*s2hat*log(s1hat^2/s2hat^2) + (2*(s1hat^2 - s2hat^2))/s2hat))/(2*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))/(s1hat^2 - s2hat^2) + (2*s2hat*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))/(s1hat^2 - s2hat^2)^2))/(2*s2hat) - (2^(1/2)*(m2hat + (m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2))/(s1hat^2 - s2hat^2)))/(2*s2hat^2)))/(pi^(1/2)*exp((m2hat + (m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2))/(s1hat^2 - s2hat^2))^2/(2*s2hat^2))) - (2*((2^(1/2)*((s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2) - 2*m3hat*s2hat + (s2hat*s3hat*(2*s2hat*log(s2hat^2/s3hat^2) + (2*(s2hat^2 - s3hat^2))/s2hat))/(2*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))/(s2hat^2 - s3hat^2) - (2*s2hat*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))/(s2hat^2 - s3hat^2)^2))/(2*s2hat) - (2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat^2)))/(pi^(1/2)*exp((m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2))^2/(2*s2hat^2))))*(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)*(((log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 + 2437993681642287/562949953421312)^2 - (1000*log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2))/147)^(1/2) - log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 - 2437993681642287/562949953421312)^(1/2))/abs(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2;
d2s3=(2^(1/2)*(((2000*2^(1/2)*((2*m2hat*s3hat + s2hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2) - (s2hat*s3hat*(2*s3hat*log(s2hat^2/s3hat^2) + (2*(s2hat^2 - s3hat^2))/s3hat))/(2*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))/(s2hat^2 - s3hat^2) + (2*s3hat*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))/(s2hat^2 - s3hat^2)^2)*(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1))/(147*pi^(1/2)*s2hat*exp((m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2))^2/(2*s2hat^2))*((erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2 - 1)) - (2*2^(1/2)*(log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 + 2437993681642287/562949953421312)*((2*m2hat*s3hat + s2hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2) - (s2hat*s3hat*(2*s3hat*log(s2hat^2/s3hat^2) + (2*(s2hat^2 - s3hat^2))/s3hat))/(2*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))/(s2hat^2 - s3hat^2) + (2*s3hat*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))/(s2hat^2 - s3hat^2)^2)*(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1))/(pi^(1/2)*s2hat*exp((m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2))^2/(2*s2hat^2))*((erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2 - 1)))/(2*((log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 + 2437993681642287/562949953421312)^2 - (1000*log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2))/147)^(1/2)) + (2^(1/2)*((2*m2hat*s3hat + s2hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2) - (s2hat*s3hat*(2*s3hat*log(s2hat^2/s3hat^2) + (2*(s2hat^2 - s3hat^2))/s3hat))/(2*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))/(s2hat^2 - s3hat^2) + (2*s3hat*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))/(s2hat^2 - s3hat^2)^2)*(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1))/(pi^(1/2)*s2hat*exp((m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2))^2/(2*s2hat^2))*((erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2 - 1)))*(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1))/(2*abs(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)*(((log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 + 2437993681642287/562949953421312)^2 - (1000*log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2))/147)^(1/2) - log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 - 2437993681642287/562949953421312)^(1/2)) - (2*((2*m2hat*s3hat + s2hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2) - (s2hat*s3hat*(2*s3hat*log(s2hat^2/s3hat^2) + (2*(s2hat^2 - s3hat^2))/s3hat))/(2*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))/(s2hat^2 - s3hat^2) + (2*s3hat*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))/(s2hat^2 - s3hat^2)^2)*(((log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 + 2437993681642287/562949953421312)^2 - (1000*log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2))/147)^(1/2) - log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 - 2437993681642287/562949953421312)^(1/2))/(pi^(1/2)*s2hat*exp((m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2))^2/(2*s2hat^2))*abs(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)) + (2*sign(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)*((2*m2hat*s3hat + s2hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2) - (s2hat*s3hat*(2*s3hat*log(s2hat^2/s3hat^2) + (2*(s2hat^2 - s3hat^2))/s3hat))/(2*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))/(s2hat^2 - s3hat^2) + (2*s3hat*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))/(s2hat^2 - s3hat^2)^2)*(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)*(((log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 + 2437993681642287/562949953421312)^2 - (1000*log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2))/147)^(1/2) - log(1 - (erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s2hat^2 - s3hat^2)*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2)/2 - 2437993681642287/562949953421312)^(1/2))/(pi^(1/2)*s2hat*exp((m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2))^2/(2*s2hat^2))*abs(erf((2^(1/2)*(m2hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2)))/(2*s2hat)) - erf(1/2*2^(1/2)/s2hat*(m2hat + 1/(s1hat^2 - s2hat^2)*(m1hat*s2hat^2 - m2hat*s1hat^2 + s1hat*s2hat*(log(s1hat^2/s2hat^2)*(s1hat^2 - s2hat^2) + (m1hat - m2hat)^2)^(1/2)))) + 1)^2);

d3s1=0;
d3s2=((s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2) - 2*m3hat*s2hat + (s2hat*s3hat*(2*s2hat*log(s2hat^2/s3hat^2) + (2*(s2hat^2 - s3hat^2))/s2hat))/(2*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))/(s2hat^2 - s3hat^2) - (2*s2hat*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))/(s2hat^2 - s3hat^2)^2)/s3hat;
d3s3=((2*m2hat*s3hat + s2hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2) - (s2hat*s3hat*(2*s3hat*log(s2hat^2/s3hat^2) + (2*(s2hat^2 - s3hat^2))/s3hat))/(2*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))/(s2hat^2 - s3hat^2) + (2*s3hat*(m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2)))/(s2hat^2 - s3hat^2)^2)/s3hat - (m3hat + (m2hat*s3hat^2 - m3hat*s2hat^2 + s2hat*s3hat*(log(s2hat^2/s3hat^2)*(s2hat^2 - s3hat^2) + (m2hat - m3hat)^2)^(1/2))/(s2hat^2 - s3hat^2))/s3hat^2;
 

%---------------------------------



%---end of partial derivatives
varm1=s1hat^2/n1; varm2=s2hat^2/n2; varm3=s3hat^2/n3;
vars1=s1hat^2/(2*(n1-1)); vars2=s2hat^2/(2*(n2-1)); vars3=s3hat^2/(2*(n3-1));


vard1=d1m1^2*varm1+d1m2^2*varm2+d1m3^2*varm3+...
      d1s1^2*vars1+d1s2^2*vars2+d1s3^2*vars3;
  
vard2=d2m1^2*varm1+d2m2^2*varm2+d2m3^2*varm3+...
      d2s1^2*vars1+d2s2^2*vars2+d2s3^2*vars3;

vard3=d3m1^2*varm1+d3m2^2*varm2+d3m3^2*varm3+...
      d3s1^2*vars1+d3s2^2*vars2+d3s3^2*vars3;
  
      
covd1d2=d1m1*d2m1*varm1+d1m2*d2m2*varm2+d1m3*d2m3*varm3+...
        d1s1*d2s1*vars1+d1s2*d2s2*vars2+d1s3*d2s3*vars3;
covd1d3=d1m1*d3m1*varm1+d1m2*d3m2*varm2+d1m3*d3m3*varm3+...
        d1s1*d3s1*vars1+d1s2*d3s2*vars2+d1s3*d3s3*vars3;
covd2d3=d2m1*d3m1*varm1+d2m2*d3m2*varm2+d2m3*d3m3*varm3+...
        d2s1*d3s1*vars1+d2s2*d3s2*vars2+d2s3*d3s3*vars3;
    

%[p1,p3] = meshgrid(0:0.05:1, 0:0.05:1);
%ROCsparam= (norminv(1-p3,m3hat,s3hat)>norminv(p1,m1hat,s1hat)).*(normcdf(norminv(1-p3,m3hat,s3hat),m2hat,s2hat)-...
%      normcdf(norminv(p1,m1hat,s1hat),m2hat,s2hat));
%h=colormap(gray);

%ROCsparam(find(ROCsparam==0))=NaN;
%surf(p1,p3,ROCsparam) %plot the ROC surface
%xlabel('TPR1');ylabel('TPR3');zlabel('TPR2')

covd2d1=covd1d2;
covd3d1=covd1d3;
covd3d2=covd2d3;
       
covdeltas=[vard1   covd1d3  covd1d2;
           covd3d1 vard3    covd3d2;
           covd2d3 covd2d3  vard2]
   covnew=[vard1   covd1d2 covd1d3;
           covd2d1 vard2    covd2d3;
           covd3d1 covd3d2  vard3];      
     

%keep the bootstrap delta covs for each MC iteration:
bcov11 =covdeltas(1,1);
bcov12 =covdeltas(1,2);
bcov13 =covdeltas(1,3);
bcov21 =covdeltas(2,1);
bcov22 =covdeltas(2,2);
bcov23 =covdeltas(2,3);
bcov31 =covdeltas(3,1);
bcov32 =covdeltas(3,2);
bcov33 =covdeltas(3,3);


aaaaacovdeltas=covdeltas
invcovdeltas=inv(covdeltas);
[U D V]=svd(invcovdeltas);
aaaaainvcovdeltas=invcovdeltas
%a=sqrt(5.99)/sqrt(D(1,1));
%b=sqrt(5.99)/sqrt(D(2,2));

a=sqrt(chi2inv(0.95,3))/sqrt(D(1,1));
b=sqrt(chi2inv(0.95,3))/sqrt(D(3,3));
c=sqrt(chi2inv(0.95,3))/sqrt(D(2,2));

%----plot the ROC surface:
% [p1,p3] = meshgrid(0:0.01:1, 0:0.01:1);
% ROCsparam= (norminv(1-p3,m3hat,s3hat)>norminv(p1,m1hat,s1hat)).*(normcdf(norminv(1-p3,m3hat,s3hat),m2hat,s2hat)-...
% normcdf(norminv(p1,m1hat,s1hat),m2hat,s2hat));
% surf(p1,p3,ROCsparam) %plot the ROC surface
% shading interp
% alpha(0.5)
% hold on
%-------------------

shading interp
alpha(0.8)
%close all
axis([0 1 0 1 0 1])
hold on
C=[(delta1hat) (delta3hat) (delta2hat)]'
[K1 K2 K3 SS]=myellipsoid(invcovdeltas, C, 20);
alpha(0.2)
xlabel('TC_{1}')
ylabel('TC_{3}')
zlabel('TC_{2}')

%XX = [normcdf(XX(1:end))', 1-normcdf(ZZ(1:end))', normcdf(YY(1:end))'];
%[K vol] = convhulln(XX);

alpha(0.8)
hold on

%mesh(normcdf(K1),1-normcdf(K2),normcdf(K3))
%shading interp
%colormap(gray);


 xyz = SS;
 [tess vol_egg] = convhulln(SS);
 volegg =vol_egg;

 
 %current_coverage=mean(in)
 
 
 %deal with the cube:
 tpr1ci=[(delta1hat)-norminv(0.9916,0,1)*sqrt(covdeltas(1,1)) (delta1hat)+norminv(0.9916,0,1)*sqrt(covdeltas(1,1))]; 
 tpr3ci=[(delta3hat)-norminv(0.9916,0,1)*sqrt(covdeltas(2,2)) (delta3hat)+norminv(0.9916,0,1)*sqrt(covdeltas(2,2))];
 tpr2ci=[(delta2hat)-norminv(0.9916,0,1)*sqrt(covdeltas(3,3)) (delta2hat)+norminv(0.9916,0,1)*sqrt(covdeltas(3,3))];



 CI1=[normcdf(tpr1ci(1)),normcdf(tpr1ci(2))];
 CI3=[normcdf(tpr3ci(1)), normcdf(tpr3ci(2))];
 CI2=[normcdf(tpr2ci(1)), normcdf(tpr2ci(2))];

 drawrect( [CI1(1) CI3(1) CI2(1)], [CI1(2)-CI1(1) abs(CI3(2)-CI3(1)) CI2(2)-CI2(1)] );
 alpha(0.7)
 volrect =abs(CI1(2)-CI1(1))*abs(CI2(2)-CI2(1))*abs(CI3(2)-CI3(1));

tpr1ci=[(delta1hat)-norminv(0.975,0,1)*sqrt(covdeltas(1,1)) (delta1hat)+norminv(0.975,0,1)*sqrt(covdeltas(1,1))]; 
tpr3ci=[(delta3hat)-norminv(0.975,0,1)*sqrt(covdeltas(2,2)) (delta3hat)+norminv(0.975,0,1)*sqrt(covdeltas(2,2))];
tpr2ci=[(delta2hat)-norminv(0.975,0,1)*sqrt(covdeltas(3,3)) (delta2hat)+norminv(0.975,0,1)*sqrt(covdeltas(3,3))];

CI1marg=[normcdf(tpr1ci(1)),normcdf(tpr1ci(2))];
CI3marg=[normcdf(tpr3ci(1)), normcdf(tpr3ci(2))];
CI2marg=[normcdf(tpr2ci(1)), normcdf(tpr2ci(2))];
 
Jhat;
vus=dblquad(ROCsurf,0,1,0,1);
outvolume=[volegg volrect];
outrect=[CI1; CI2; CI3];
covdeltas_plot=covdeltas
covdeltas=covnew;
deltas=[delta1 delta2 delta3];
cutoffs=[c1hat c2hat];



marginalCIs=[CI1marg;CI2marg;CI3marg];
deltas=[delta1 delta2 delta3];
TC123=normcdf([deltas]);
 
hold off

end